<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="故障分类" prop="categoryId">
        <el-select v-model="formData.categoryId" clearable filterable placeholder="请选择故障分类">
          <el-option
v-for="item in categoryList"
                     :key="item.id"
                     :label="item.categoryName"
                     :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="故障编码" prop="sceneCode">
        <el-input v-model="formData.sceneCode" placeholder="请输入故障编码" />
      </el-form-item>
      <el-form-item label="故障名称" prop="sceneName">
        <el-input v-model="formData.sceneName" placeholder="请输入故障名称" />
      </el-form-item>
      <el-form-item label="标准耗时" prop="hours">
        <el-input-number v-model="formData.hours" placeholder="请输入标准耗时" />
      </el-form-item>
      <el-form-item label="维修方案" prop="solution">
        <el-input type="textarea" v-model="formData.solution" placeholder="请输入维修方案" />
      </el-form-item>
      <el-form-item label="附件" prop="pics">
        <UploadFile v-model="formData.pics" isShowTip="false" fileSize="10" limit="1" />
      </el-form-item>
<!--      <el-form-item label="排序" prop="sort">-->
<!--        <el-input v-model="formData.sort" placeholder="请输入排序" />-->
<!--      </el-form-item>-->
      <el-form-item label="状态" prop="state">
        <el-select
            v-model="formData.state"
            placeholder="请选择状态"
            clearable
        >
          <el-option
              v-for="dict in getIntDictOptions(DICT_TYPE.EFFECTIVE_STATUS)"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
          />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { RepairFaultSceneApi, RepairFaultSceneVO } from '@/api/device/repairfaultscene'
import {RepairFaultCategoryApi, RepairFaultCategoryVO} from "@/api/device/repairfaultcategory";
import {DICT_TYPE, getIntDictOptions} from "@/utils/dict";

/** 设备维修故障类型 表单 */
defineOptions({ name: 'RepairFaultSceneForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  categoryId: undefined,
  sceneCode: undefined,
  sceneName: undefined,
  hours: undefined,
  solution: undefined,
  pics: '',
  sort: 0,
  state: 1,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()

  getCategoryList();
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await RepairFaultSceneApi.getRepairFaultScene(id)
      if (formData.value.pics ){
        formData.value.pics = formData.value.pics.split(',');
      }
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as RepairFaultSceneVO
    if (data.pics && Array.isArray(data.pics)){
      data.pics = data.pics.join(',');
    }
    if (formType.value === 'create') {
      await RepairFaultSceneApi.createRepairFaultScene(data)
      message.success(t('common.createSuccess'))
    } else {
      await RepairFaultSceneApi.updateRepairFaultScene(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    categoryId: undefined,
    sceneCode: undefined,
    sceneName: undefined,
    hours: undefined,
    solution: undefined,
    pics: undefined,
    sort: undefined,
    state: undefined,
  }
  formRef.value?.resetFields()
}

const categoryList = ref<RepairFaultCategoryVO[]>([]) // 分类数据
const getCategoryList = async () => {
  const data = await RepairFaultCategoryApi.getRepairFaultCategoryPage({
    pageNo: 1,
    pageSize: 100,
  })
  categoryList.value = data.list;
}
</script>
